;!function(){try{var k="_btDebugIds",u="undefined",v="7938ad4d-4251-087d-bf2f-8d12a656b91b",a=function(x){try{x[k]=x[k]||{};x[k][n]=v}catch{}},n=(new Error).stack;n&&(u!=typeof window?a(window):u);n&&(u!=typeof global?a(global):u);n&&(u!=typeof self?a(self):u);n&&(u!=typeof globalThis?a(globalThis):u)}catch{}}();
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const errors_1 = require("../lib/errors");
const util_1 = require("../lib/util");
const commitRulesController = (db, service, urlPrefix) => {
    service.app.get(`${urlPrefix}/:universeName/:projectName/commit_rules`, service.identityManager.authenticateRequest(), (0, util_1.accessCheck)(service), (0, util_1.asyncWrapper)(async (req, res, _next) => {
        let commitRules;
        const repositoryId = req.query.repository_id;
        commitRules = await db("commit_rules")
            .select("*")
            .where("repository_id", repositoryId);
        return res.send({ commit_rules: commitRules });
    }));
    service.app.put(`${urlPrefix}/:universeName/:projectName/commit_rules/:id`, service.identityManager.authenticateRequest(), (0, util_1.accessCheck)(service), (0, util_1.adminCheck)(service), (0, util_1.asyncWrapper)(async (req, res, _next) => {
        const id = req.params.id;
        const { position } = req.body;
        if (!Number.isInteger(position)) {
            return res.status(422).send((0, errors_1.getError)(9, "Position not specified"));
        }
        const commitRule = await db("commit_rules").first("*").where("id", id);
        if (!commitRule) {
            return res
                .status(404)
                .send((0, errors_1.getError)(8, `Commit rule with id ${id} not found`));
        }
        const origPos = commitRule.position;
        const newPos = position;
        await (0, util_1.updatePosition)({
            db,
            origPos,
            newPos,
            rowId: commitRule.id,
            tableName: "commit_rules",
            extendQueryCb: (q) => q.where("repository_id", commitRule.repository_id),
        });
        const newCommitRule = await db("commit_rules")
            .first("*")
            .where("id", id);
        return res.send({ commit_rule: newCommitRule });
    }));
    service.app.post(`${urlPrefix}/:universeName/:projectName/commit_rules`, service.identityManager.authenticateRequest(), (0, util_1.accessCheck)(service), (0, util_1.adminCheck)(service), (0, util_1.asyncWrapper)(async (req, res, _next) => {
        const { repository_id, attribute_template, position = 0 } = req.body;
        const createProps = {
            repository_id,
            position,
            attribute_template,
        };
        const newCommitId = await (0, util_1.createSpaceAtPosition)({
            db,
            pos: position,
            tableName: "commit_rules",
            extendQueryCb: (q) => q.where("repository_id", repository_id),
            trxCb: (trx) => trx("commit_rules").insert(createProps),
        });
        return res.send({ commit_rule: newCommitId });
    }));
    service.app.delete(`${urlPrefix}/:universeName/:projectName/commit_rules/:id`, service.identityManager.authenticateRequest(), (0, util_1.accessCheck)(service), (0, util_1.adminCheck)(service), (0, util_1.asyncWrapper)(async (req, res, _next) => {
        const id = req.params.id;
        if (!Number.isInteger(parseInt(id, 10))) {
            return res.status(422).send((0, errors_1.getError)(2, "Invalid ID"));
        }
        await db("commit_rules").where("id", id).del();
        return res.status(200).send();
    }));
};
exports.default = commitRulesController;
//# sourceMappingURL=commit_rules.js.map
//# debugId=7938ad4d-4251-087d-bf2f-8d12a656b91b