;!function(){try{var k="_btDebugIds",u="undefined",v="076c3960-8467-d311-01b7-5935f5378066",a=function(x){try{x[k]=x[k]||{};x[k][n]=v}catch{}},n=(new Error).stack;n&&(u!=typeof window?a(window):u);n&&(u!=typeof global?a(global):u);n&&(u!=typeof self?a(self):u);n&&(u!=typeof globalThis?a(globalThis):u)}catch{}}();
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.gitVersion = exports.gitGarbageCollect = exports.gitCmdPath = exports.evaluatePerforceRules = exports.getSubmoduleAncestor = exports.getUnclonedSubmodulesForProject = exports.getUnclonedSubmodules = exports.getCandidateRepos = exports.cloneSubmodulesRecursivelyForProject = exports.cloneSubmodulesRecursively = exports.getSubmoduleInfoForDb = exports.cloneRepo = exports.getSubmCommitFromParent = exports.getSubmoduleCommits = exports.reposPath = exports.repoPath = exports.readGitmodules = exports.getMatchingFile = exports.getFileFromRepo = exports.evaluateRule = exports.getCommits = exports.getFilePath = exports.gitCloneExn = exports.gitLsTreeSubm = exports.gitLsTreeMatch = exports.gitLsTree = exports.gitFetchOrClone = exports.gitFetchOrCloneSpawn = exports.gitFetchExn = exports.gitFetch = exports.gitShow = exports.getCommit = exports.getRepo = exports.gitCmd = exports.newGit = void 0;
const child_process_1 = require("child_process");
const nodegit_1 = require("nodegit");
const backtrace_service_1 = require("backtrace-service");
const filepath_matching_1 = require("../lib/filepath_matching");
const util_1 = require("../lib/util");
const perforce_1 = require("../lib/perforce");
const do_not_use_list_1 = __importDefault(require("../lib/do_not_use_list"));
const path_1 = __importDefault(require("path"));
const fs_1 = __importDefault(require("fs"));
const thisModule = __importStar(require("./git_routines"));
const rimraf_1 = __importDefault(require("rimraf"));
const ssh_1 = require("./ssh");
const log = backtrace_service_1.Logger.getLogger();
const cache_1 = __importDefault(require("../lib/cache"));
const gitCmdPath = () => {
    let cachedPath = null;
    return (cachedPath ||
        (function gitCmdPath2() {
            var _a, _b;
            if (!cachedPath) {
                cachedPath =
                    process.env.GITCMD ||
                        ((_b = (_a = global.service) === null || _a === void 0 ? void 0 : _a.configuration) === null || _b === void 0 ? void 0 : _b.gitcmd) ||
                        "/opt/backtrace/bin/git";
            }
            return cachedPath;
        })());
};
exports.gitCmdPath = gitCmdPath;
async function gitFetchExn(gitRepo, dbRepo) {
    const { id, auth_type, ssh_private_key } = dbRepo;
    if (id === undefined)
        throw new Error("Repo ID is undefined");
    const path = repoPath(id);
    if (auth_type === "user_pass") {
        await newGit.fetchUserPassExn(path);
    }
    else if (auth_type === "none") {
        const res = await newGit.fetchOpenExn(path);
    }
    else if (auth_type === "ssh_key" && ssh_private_key) {
        await newGit.fetchSSHExn(path, ssh_private_key);
    }
    else {
        throw new Error(`Unknown auth_type ${auth_type}`);
    }
}
exports.gitFetchExn = gitFetchExn;
async function gitFetch(gitRepo, dbRepo, db) {
    try {
        await gitFetchExn(gitRepo, dbRepo);
        await db("repositories")
            .where("id", dbRepo.id)
            .update({ last_fetched: db.fn.now(), fetch_err: "" });
    }
    catch (e) {
        e.message = `gitFetch (repo ${dbRepo.id}): ` + e.message;
        log.error(e, { source: "gitFetch", repo: dbRepo.id });
        await db("repositories").where("id", dbRepo.id).update({
            fetch_err: e.message,
        });
    }
}
exports.gitFetch = gitFetch;
async function gitFetchOrClone(dbRepo, db) {
    const gitRepo = await getRepoOrClone(dbRepo);
    if (gitRepo === null)
        return null;
    await gitFetch(gitRepo, dbRepo, db);
}
exports.gitFetchOrClone = gitFetchOrClone;
async function getRepoOrClone(dbRepo) {
    let gitRepo = null;
    try {
        gitRepo = await newGit.getRepo(dbRepo.id);
    }
    catch (e) {
        if (/No such file or directory/.test(e.message)) {
            try {
                await gitCloneExn(dbRepo);
                gitRepo = await newGit.getRepo(dbRepo.id);
            }
            catch (e) {
                e.message = `getRepoOrClone (repo ${dbRepo.id}): ` + e.message;
                log.error(e, { source: "getRepoOrClone", repo: dbRepo.id });
            }
        }
    }
    return gitRepo;
}
function gitGarbageCollect(id) {
    return new Promise((resolve, reject) => {
        const cwd = repoPath(id);
        const args = ["gc"];
        const childProcess = (0, child_process_1.spawn)(gitCmdPath(), args, {
            cwd,
        });
        const { stdout, stderr } = childProcess;
        childProcess.on("error", (e) => {
            reject(e);
        });
        const err = "";
        stderr.on("data", (data) => {
            err.concat(data.toString());
        });
        let out = "";
        stdout.on("data", (data) => {
            out.concat(data.toString());
        });
        childProcess.on("close", (code) => {
            if (code !== 0) {
                reject(`[gitGarbageCollect] exited with non-zero status ${code}\n ${err}`);
            }
            else {
                resolve(out);
            }
        });
    });
}
exports.gitGarbageCollect = gitGarbageCollect;
function gitFetchOrCloneSpawn(id) {
    const fetch = (0, child_process_1.spawn)("node", [path_1.default.resolve("dist", "tasks", "fetch_or_clone_repo.js"), id], {
        env: {
            NODE_ENV: process.env.NODE_ENV,
        },
    });
    fetch.stdout.on("data", (data) => {
        data = data.toString();
        if (/logger instance/i.test(data))
            return;
        if (/Reading configuration file/i.test(data))
            return;
        if (/metrics/i.test(data))
            return;
        if (/circonus/i.test(data))
            return;
        if (/Initializing backtrace-node/i.test(data))
            return;
        if (/integration/i.test(data))
            return;
        data = data.replace(/\n/g, "  ");
        console.error(`gitFetchOrCloneSpawn(${id}): ${data}`);
    });
    fetch.stderr.on("data", (data) => {
        data = data.toString().replace(/\n/g, "  ");
        console.error(`gitFetchOrCloneSpawn(${id}): ${data}`);
    });
    return new Promise((resolve, reject) => fetch.on("exit", (code) => (code === 0 ? resolve() : reject())));
}
exports.gitFetchOrCloneSpawn = gitFetchOrCloneSpawn;
async function getCommit(repo, commitish) {
    let obj;
    try {
        obj = await nodegit_1.Revparse.single(repo, commitish);
    }
    catch (e) {
        obj = await nodegit_1.Revparse.single(repo, `origin/${commitish}`);
    }
    if ("tag" === nodegit_1.Object.type2String(obj.type())) {
        const tag = await nodegit_1.Tag.lookup(repo, obj.id());
        obj = await tag.target();
    }
    const commit = nodegit_1.Commit.lookup(repo, obj.id());
    return commit;
}
exports.getCommit = getCommit;
let cachedPath = null;
function reposPath() {
    return (cachedPath ||
        (function reposPath2() {
            var _a, _b;
            if (!cachedPath) {
                cachedPath =
                    process.env.REPOSPATH ||
                        ((_b = (_a = global.service) === null || _a === void 0 ? void 0 : _a.configuration) === null || _b === void 0 ? void 0 : _b.reposPath) ||
                        (process.env.NODE_ENV === "test"
                            ? path_1.default.resolve("test", "reposTmp")
                            : path_1.default.resolve("repos"));
            }
            if (!cachedPath)
                throw "[reposPath] Undefined reposPath";
            return cachedPath;
        })());
}
exports.reposPath = reposPath;
function repoPath(repoId) {
    return path_1.default.resolve(reposPath(), repoId.toString());
}
exports.repoPath = repoPath;
async function getRepo(repoId) {
    const pathToRepo = repoPath(repoId);
    return await nodegit_1.Repository.open(pathToRepo);
}
exports.getRepo = getRepo;
async function gitLsTreeMatch(universeName, projectName, repoId, repo, commit, matchRegex) {
    const lsTree = await gitLsTree(universeName, projectName, repoId, repo, commit);
    return lsTree.filter((item) => matchRegex.test(item));
}
exports.gitLsTreeMatch = gitLsTreeMatch;
async function gitLsTree(universeName, projectName, repoId, repo, commit) {
    return new Promise(async function gitLsTree2(resolve, reject) {
        const ckey = `${repoId}_${commit.sha()}`;
        const item = await cache_1.default.get({
            universe_name: universeName,
            project_name: projectName,
            ckey,
        });
        if (item !== null) {
            try {
                const lstree = JSON.parse(item.cvalue);
                return resolve(lstree);
            }
            catch (e) {
                log.warn(`Unable to parse cache item with (universe, project, ckey) = (${universeName}, ${projectName}, ${ckey})`);
            }
        }
        const commitTree = await commit.getTree();
        const walker = commitTree.walk();
        const matches = [];
        walker
            .on("entry", (entry) => {
            matches.push(entry.path());
        })
            .on("end", () => {
            cache_1.default
                .set({
                universe_name: universeName,
                project_name: projectName,
                ckey,
                ctype: "git_ls_tree",
                cvalue: JSON.stringify(matches),
            })
                .catch((e) => log.warn("unable to set in cache: " + e));
            resolve(matches);
        });
        walker.start();
    });
}
exports.gitLsTree = gitLsTree;
async function gitCmd({ args, cwd, timeout, env, opts, }) {
    if (cwd !== undefined && !fs_1.default.existsSync(cwd)) {
        throw new Error("cwd does not exist, spawnSync() will throw an error");
    }
    const { stdout, stderr, error } = (0, child_process_1.spawnSync)(gitCmdPath(), args, {
        cwd,
        env: Object.assign({ GIT_AUTHOR_NAME: "backtrace-source-code service", GIT_AUTHOR_EMAIL: "support@backtrace.io", GIT_COMMITTER_NAME: "backtrace-source-code service", GIT_COMMITTER_EMAIL: "support@backtrace.io" }, (env !== null && env !== void 0 ? env : {})),
        timeout,
    });
    if (error) {
        throw error;
    }
    if (stderr.length > 0) {
        const msg = stderr.toString();
        let should_suppress = false;
        if (opts && opts.suppress_warnings && opts.suppress_warnings.length > 0) {
            should_suppress =
                opts.suppress_warnings.map((w) => w.test(msg)).filter((a) => a === true)
                    .length > 0;
        }
        if (!should_suppress)
            throw new Error(msg);
    }
    return stdout.toString();
}
exports.gitCmd = gitCmd;
async function gitLsTreeSubm(parentRepoId, repo, commitHash) {
    let commit;
    try {
        commit = await getCommit(repo, commitHash);
    }
    catch (e) {
        log.warn("gitLsTreeSubm: " + e);
        return [];
    }
    const sanitizedCommitHash = commit.sha();
    const { stdout, stderr } = (0, child_process_1.spawnSync)(gitCmdPath(), ["ls-tree", "-d", "-r", sanitizedCommitHash], {
        cwd: repoPath(parentRepoId),
    });
    const errStr = stderr.toString();
    if (errStr.length > 0) {
        throw errStr;
    }
    const RE = /.*? (.*?) (.*?)\t(.*)/;
    const ret = [];
    stdout
        .toString()
        .split("\n")
        .forEach((line) => {
        const match = RE.exec(line);
        if (match) {
            const [, itemType, submCommit, submPath] = match;
            if (itemType === "commit") {
                ret.push([submPath, submCommit]);
            }
        }
    });
    return ret;
}
exports.gitLsTreeSubm = gitLsTreeSubm;
async function getSubmCommitFromParent(parentRepoId, parentRepo, commit, submodulePath) {
    let submCommits = await gitLsTreeSubm(parentRepoId, parentRepo, commit);
    submCommits = submCommits.filter(([submPath, _]) => submPath === submodulePath);
    if (submCommits.length === 0)
        return null;
    const [, submCommit] = submCommits[0];
    return submCommit;
}
exports.getSubmCommitFromParent = getSubmCommitFromParent;
function getSurroundingLines(surroundingLines, faultingLine, fileContents) {
    if (surroundingLines &&
        Number.isInteger(surroundingLines) &&
        faultingLine &&
        Number.isInteger(faultingLine)) {
        const fileContentsSplit = fileContents.split(/\r?\n/);
        const totalLines = fileContentsSplit.length;
        let startLine = faultingLine - surroundingLines;
        let endLine = faultingLine + surroundingLines;
        if (startLine < 0) {
            startLine = 1;
        }
        if (endLine > fileContentsSplit.length - 1) {
            endLine = fileContentsSplit.length - 1;
        }
        const context = fileContentsSplit
            .slice(startLine - 1, endLine + 1)
            .join("\n");
        return { context, startLine, totalLines };
    }
    else {
        return { context: fileContents, startLine: null, totalLines: null };
    }
}
function gitBlame(sanitizedCommitHash, sanitizedFilePath, blameArgs, repoId) {
    const { stdout, stderr } = (0, child_process_1.spawnSync)(gitCmdPath(), [...blameArgs, sanitizedCommitHash, sanitizedFilePath], {
        cwd: repoPath(repoId),
    });
    const errStr = stderr.toString();
    if (errStr.length > 0) {
        throw errStr;
    }
    let fileContents = "";
    let blame = "";
    let timeStamps = "";
    let commits = "";
    stdout
        .toString()
        .split("\n")
        .forEach((line) => {
        const splitLine = line.split("\t");
        if (splitLine.length >= 4) {
            let email = splitLine[1];
            email = email.slice(2, email.indexOf("@"));
            let codeLine = splitLine.slice(3).join("\t");
            codeLine = codeLine.slice(codeLine.indexOf(")") + 1);
            fileContents += codeLine + "\n";
            commits += splitLine[0] + "\n";
            blame += email + "\n";
            timeStamps += splitLine[2] + "\n";
        }
        return splitLine;
    });
    return { fileContents, blame, timeStamps, commits };
}
async function gitShow({ repo, repoId, commitHashUnsanitized, filePathUnsanitized, faultingLine, surroundingLines = null, includeBlame, universeName, projectName, }) {
    return new Promise(async function gitShow2(resolve, reject) {
        try {
            const commit = await getCommit(repo, commitHashUnsanitized);
            const treeEntry = await commit.getEntry(filePathUnsanitized);
            const sanitizedCommitHash = commit.sha();
            const sanitizedFilePath = treeEntry.path();
            let blameArgs = ["blame", "-c", "-e", "--date=short"];
            const totalLines = treeEntry.isFile()
                ? (await treeEntry.getBlob()).toString().split(/\r?\n/).length
                : null;
            if (includeBlame === true) {
                let startLine = null;
                let endLine = null;
                if (surroundingLines &&
                    Number.isInteger(surroundingLines) &&
                    faultingLine &&
                    Number.isInteger(faultingLine)) {
                    startLine = faultingLine - surroundingLines;
                    if (startLine < 0) {
                        startLine = 1;
                    }
                    endLine = faultingLine + surroundingLines;
                    if (endLine && totalLines && endLine > totalLines) {
                        endLine = totalLines - 1;
                    }
                    blameArgs = [...blameArgs, "-L", `${startLine},${endLine}`];
                }
                const { fileContents, blame, timeStamps, commits } = gitBlame(sanitizedCommitHash, sanitizedFilePath, blameArgs, repoId);
                resolve({
                    fileContents,
                    blame,
                    timeStamps,
                    commits,
                    startLine,
                    totalLines,
                });
            }
            else {
                let fileContents = null;
                const ckey = `${sanitizedCommitHash}_${sanitizedFilePath}`;
                const item = await cache_1.default.get({
                    universe_name: universeName,
                    project_name: projectName,
                    ckey,
                    ctype: "git_show",
                });
                if (item !== null)
                    fileContents = item.cvalue;
                if (fileContents == null) {
                    if (treeEntry.isFile()) {
                        fileContents = (await treeEntry.getBlob()).toString();
                        cache_1.default
                            .set({
                            universe_name: universeName,
                            project_name: projectName,
                            ckey,
                            ctype: "git_show",
                            cvalue: fileContents,
                        })
                            .catch((e) => log.warn("unable to set in cache: " + e));
                    }
                    else {
                        fileContents = "Not a valid file";
                    }
                }
                const { context, startLine, totalLines } = getSurroundingLines(surroundingLines, faultingLine, fileContents);
                resolve({
                    fileContents: context,
                    blame: null,
                    timeStamps: null,
                    commits: null,
                    startLine,
                    totalLines,
                });
            }
        }
        catch (e) {
            reject(e);
        }
    });
}
exports.gitShow = gitShow;
async function getFilePath(universeName, projectName, repoId, repo, commit, fileName, fullPath, searchLog) {
    let candidates;
    const fileNameSanitized = (0, util_1.escapeRegExp)(fileName);
    candidates = await gitLsTreeMatch(universeName, projectName, repoId, repo, commit, new RegExp(`(^|/)${fileNameSanitized}$`, "i"));
    if (candidates.length === 0) {
        searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Found zero candidates for ${fileName} at revision ${commit.sha()}.`);
        return null;
    }
    const bestCandidates = candidates
        .map((candidatePath) => [(0, filepath_matching_1.calcScore)(fullPath, candidatePath), candidatePath])
        .sort((a, b) => a[0] - b[0]);
    const bestCandidatesSample = bestCandidates
        .slice(10)
        .map((bc) => `Match score: ${bc[0]}, path: ${bc[1]}`);
    searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Found ${bestCandidates.length} candidates for ${fileName} at revision ${commit.sha()}. Top 10 best matches for ${fullPath}:\n ${bestCandidatesSample.join("\n")}.`);
    return bestCandidates[bestCandidates.length - 1][1];
}
exports.getFilePath = getFilePath;
async function getCommits(repo, attributes, db, universeName, projectName, searchLog) {
    if (repo.submodule_parent_repo) {
        return await getSubmoduleCommits(repo, attributes, db, universeName, projectName, searchLog);
    }
    const repoId = repo.id;
    const defaultCommit = repo.default_commit;
    const commitRules = await db("commit_rules")
        .select("*")
        .where({ repository_id: repoId })
        .orderBy("position");
    if (commitRules.length === 0) {
        return [defaultCommit];
    }
    else {
        const commitList = commitRules.map((cr) => cr.attribute_template.replace(/.*?({(.*?)}).*/, (attrTemplate, templateFragment, attributeName) => {
            if (!attributes[attributeName]) {
                searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Attribute ${attributeName} not available. Skipping commit ${attrTemplate}.`);
                return "ATTRIBUTE_NOT_FOUND";
            }
            else {
                return attrTemplate.replace(templateFragment, attributes[attributeName]);
            }
        }));
        return [...commitList, defaultCommit];
    }
}
exports.getCommits = getCommits;
var MatchAction;
(function (MatchAction) {
    MatchAction[MatchAction["Match"] = 0] = "Match";
    MatchAction[MatchAction["NoMatch"] = 1] = "NoMatch";
    MatchAction[MatchAction["Skip"] = 2] = "Skip";
    MatchAction[MatchAction["MatchStop"] = 3] = "MatchStop";
    MatchAction[MatchAction["FullStop"] = 4] = "FullStop";
    MatchAction[MatchAction["Unknown"] = 5] = "Unknown";
})(MatchAction || (MatchAction = {}));
function evaluateRule(rule, obj) {
    const re = new RegExp(rule.regex);
    let value = null;
    if (rule.field_type === "file_name") {
        value = obj.fullPath;
    }
    else if (rule.field_type === "function_name") {
        value = obj.functionName;
    }
    else if (rule.field_type === "object_name") {
        value = obj.objectName;
    }
    else if (rule.field_type === "attribute") {
        value = obj.attributes[rule.field_name];
    }
    else {
        value = null;
    }
    if (value != null && re.test(value)) {
        if (rule.action === "match") {
            return MatchAction.Match;
        }
        else if (rule.action === "skip") {
            return MatchAction.Skip;
        }
        else if (rule.action === "match_stop") {
            return MatchAction.MatchStop;
        }
        else if (rule.action === "full_stop") {
            return MatchAction.FullStop;
        }
        else {
            return MatchAction.Unknown;
        }
    }
    else {
        return MatchAction.NoMatch;
    }
}
exports.evaluateRule = evaluateRule;
async function getSubmoduleCommits(repo, attributes, db, universeName, projectName, searchLog) {
    var _a;
    if (repo.submodule_parent_repo) {
        const parentRepoId = repo.submodule_parent_repo;
        const parentRepoDb = await db("repositories")
            .first("*")
            .where("id", parentRepoId);
        const parentRepo = await getRepo(parentRepoId);
        const parentRepoCommits = await getCommits(parentRepoDb, attributes, db, universeName, projectName, searchLog);
        const ret = [];
        for (const parentCommit of parentRepoCommits) {
            let submCommits = await gitLsTreeSubm(parentRepoId, parentRepo, parentCommit);
            if (submCommits.length === 0)
                continue;
            const parentGitmodulesAtCommit = await readGitmodules(parentRepoId, parentCommit, universeName, projectName);
            const submodulePath = (_a = parentGitmodulesAtCommit[repo.name]) === null || _a === void 0 ? void 0 : _a.path;
            if (!submodulePath)
                continue;
            submCommits = submCommits.filter(([submPath, _]) => submPath === submodulePath);
            if (submCommits.length > 0) {
                const [, submCommit] = submCommits[0];
                ret.push(submCommit);
            }
        }
        return ret;
    }
    else {
        return [];
    }
}
exports.getSubmoduleCommits = getSubmoduleCommits;
async function getFileFromRepo({ universeName, projectName, repo, nodegitRepo, obj, db, searchLog, stats, }) {
    searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Searching repository ${repo.name} (${repo.id}).`);
    stats === null || stats === void 0 ? void 0 : stats.inc("num_repos_searched");
    const repoId = repo.id;
    const commits = await getCommits(repo, obj.attributes, db, universeName, projectName, searchLog);
    for (const commit of commits) {
        if (commit === "ATTRIBUTE_NOT_FOUND") {
            continue;
        }
        let nodegitCommit;
        try {
            nodegitCommit = await getCommit(nodegitRepo, commit);
        }
        catch (e) {
            if (e.errorFunction === "Revparse.single") {
                continue;
            }
            throw e;
        }
        const matchingFilePath = await getFilePath(universeName, projectName, repo.id, nodegitRepo, nodegitCommit, obj.fileName, obj.fullPath, searchLog);
        if (matchingFilePath === null) {
            continue;
        }
        const match = {
            repo: nodegitRepo,
            repoName: repo.name,
            repoId,
            filePath: matchingFilePath,
            commitHash: commit,
            commitDate: nodegitCommit.date(),
        };
        return match;
    }
    return null;
}
exports.getFileFromRepo = getFileFromRepo;
async function evaluatePerforceRules(universeName, projectName, obj, db, doNotUse, searchLog) {
    const rules = await db("perforce_rules")
        .select("*")
        .where({ universe_name: universeName, project_name: projectName })
        .orderBy("position");
    const candidateIds = [];
    for (const rule of rules) {
        searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Evaluating rule ${rule.id} (at position ${rule.position}).`);
        switch (evaluateRule(rule, obj)) {
            case MatchAction.Match:
                searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Rule match: prioritize server ${rule.matching_perforce_id}.`);
                candidateIds.push(rule.matching_perforce_id);
                break;
            case MatchAction.NoMatch:
                searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Rule does not match.`);
                break;
            case MatchAction.MatchStop:
                searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Rule match: use server ${rule.matching_perforce_id}.`);
                return await db("perforce_servers").select("*").where({
                    universe_name: universeName,
                    project_name: projectName,
                    id: rule.matching_perforce_id,
                });
            case MatchAction.FullStop:
                searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Rule match: do not search any servers.`);
                return [];
            case MatchAction.Skip:
                doNotUse.push({
                    repoId: rule.matching_perforce_id,
                    reason: "ruleSkip",
                });
                searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Rule match: do NOT use server ${rule.matching_perforce_id}.`);
                break;
            case MatchAction.Unknown:
            default:
                log.error("Unknown match error");
                searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Unknown match error for rule ${rule.id}.`);
        }
    }
    const candidates = await db("perforce_servers")
        .select("*")
        .where({
        universe_name: universeName,
        project_name: projectName,
    })
        .whereIn("id", candidateIds)
        .orderBy("created_at");
    const remainingCandidates = await db("perforce_servers")
        .select("*")
        .where({
        universe_name: universeName,
        project_name: projectName,
    })
        .whereNotIn("id", doNotUse.ids().concat(candidateIds))
        .orderBy("created_at");
    return candidates.concat(remainingCandidates);
}
exports.evaluatePerforceRules = evaluatePerforceRules;
async function getCandidateRepos(db, universeName, projectName, obj, doNotUse, searchLog) {
    const rules = await db("rules")
        .select("*")
        .where({ universe_name: universeName, project_name: projectName })
        .orderBy("position");
    const candidateIds = [];
    for (const rule of rules) {
        searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Evaluating rule ${rule.id} (at position ${rule.position}).`);
        switch (evaluateRule(rule, obj)) {
            case MatchAction.Match:
                searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Rule match: use repository ${rule.matching_repository_id}.`);
                candidateIds.push(rule.matching_repository_id);
                break;
            case MatchAction.NoMatch:
                searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Rule does not match.`);
                break;
            case MatchAction.Skip:
                doNotUse.push({
                    repoId: rule.matching_repository_id,
                    reason: "ruleSkip",
                });
                searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Rule match: do NOT use repository ${rule.matching_repository_id}.`);
                break;
            case MatchAction.Unknown:
            default:
                log.error("Unknown match error");
                searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Unknown match error for rule ${rule.id}.`);
        }
    }
    const candidates = await db("repositories")
        .select("*")
        .where({
        universe_name: universeName,
        project_name: projectName,
    })
        .whereIn("id", candidateIds)
        .orderBy("created_at");
    const remainingRepos = await db("repositories")
        .select("*")
        .where({
        universe_name: universeName,
        project_name: projectName,
    })
        .whereNotIn("id", doNotUse.ids().concat(candidateIds))
        .orderBy("created_at");
    return candidates.concat(remainingRepos);
}
exports.getCandidateRepos = getCandidateRepos;
async function getMatchingFile({ universeName, projectName, obj, db, searchLog, stats, }) {
    const rules = await db("rules")
        .select("*")
        .where({ universe_name: universeName, project_name: projectName })
        .orderBy("position");
    const doNotUse = new do_not_use_list_1.default();
    searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Evaluating ${rules.length} rules.`);
    for (const rule of rules) {
        searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Evaluating rule ${rule.id} (at position ${rule.position}).`);
        const dnuEntry = doNotUse.getEntry(rule.matching_repository_id);
        if (dnuEntry !== null) {
            searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Rule ${rule.id}: Repository (id: ${rule.matching_repository_id}) marked as do not use: ${dnuEntry.reason}.`);
            continue;
        }
        switch (evaluateRule(rule, obj)) {
            case MatchAction.Match:
                const repo = await db("repositories").first("*").where({
                    universe_name: universeName,
                    project_name: projectName,
                    id: rule.matching_repository_id,
                });
                if (!repo) {
                    log.error(`Rule ${rule.id} is missing its matching repo ${rule.matching_repository_id}`);
                    searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Rule ${rule.id} matched but its matching repository (${rule.matching_repository_id}) no longer exists.`);
                    doNotUse.push({
                        repoId: rule.matching_repository_id,
                        reason: "missingRepo",
                    });
                    break;
                }
                const nodegitRepo = await getRepo(repo.id);
                const file = await getFileFromRepo({
                    universeName,
                    projectName,
                    repo,
                    nodegitRepo,
                    obj,
                    db,
                    searchLog,
                    stats,
                });
                if (file !== null) {
                    searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Rule matched, requested file found in repository ${repo.id} at ${file.filePath}.`);
                    return file;
                }
                else {
                    doNotUse.push({ repoId: repo.id, reason: "fileNotFound" });
                    searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Rule matched, requested file NOT found in repository ${repo.name} (${repo.id}) at any of its revisions.`);
                }
                break;
            case MatchAction.NoMatch:
                searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Rule does not match.`);
                break;
            case MatchAction.Skip:
                doNotUse.push({
                    repoId: rule.matching_repository_id,
                    reason: "ruleSkip",
                });
                searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Rule matches and specifies that this repository should not be used to fulfill this request.`);
                break;
            case MatchAction.Unknown:
            default:
                log.error("Unknown match error");
                searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Unknown match error.`);
        }
    }
    searchLog === null || searchLog === void 0 ? void 0 : searchLog.push("All rules evaluated but did not result in a matching source code file.");
    const remainingRepos = await db("repositories")
        .select("*")
        .where({
        universe_name: universeName,
        project_name: projectName,
    })
        .whereNotIn("id", doNotUse.ids())
        .orderBy("created_at");
    searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`Searching for source code within ${remainingRepos.length} remaining repositories.`);
    for (const repo of remainingRepos) {
        let nodegitRepo;
        try {
            nodegitRepo = await getRepo(repo.id);
        }
        catch (e) {
            let errStr = `Could not open repository ${repo.id}.`;
            if (repo.clone_status !== "complete") {
                errStr += ` Repository clone state: ${repo.clone_status}.`;
            }
            if (repo.clone_error) {
                errStr += ` Clone error: ${repo.clone_error}.`;
            }
            log.error(errStr);
            searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(errStr);
            continue;
        }
        const file = await getFileFromRepo({
            universeName,
            projectName,
            repo,
            nodegitRepo,
            obj,
            db,
            searchLog,
            stats,
        });
        if (file !== null) {
            searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`File ${file.filePath} found in repository ${repo.name} (${repo.id}).`);
            return file;
        }
        else {
            searchLog === null || searchLog === void 0 ? void 0 : searchLog.push(`File not found in repository ${repo.name} (${repo.id}).`);
        }
    }
    const p4candidates = await evaluatePerforceRules(universeName, projectName, obj, db, doNotUse, searchLog);
    const serversPathsJoin = await db("perforce_paths")
        .join("perforce_servers", "perforce_paths.perforce_server_id", "=", "perforce_servers.id")
        .select("*")
        .orderBy("perforce_servers.id", "perforce_paths.position")
        .whereIn("perforce_servers.id", p4candidates.map((p) => p.id));
    for (const serverPath of serversPathsJoin) {
        const templatedPath = serverPath.path.replace(/.*?({(.*?)}).*/, (attrTemplate, templateFragment, attributeName) => {
            if (!obj.attributes[attributeName]) {
                return "ATTRIBUTE_NOT_FOUND";
            }
            return attrTemplate.replace(templateFragment, obj.attributes[attributeName]);
        });
        if (templatedPath === "ATTRIBUTE_NOT_FOUND") {
            continue;
        }
        const candidates = await (0, perforce_1.p4ListFiles)(obj.fileName, serverPath, templatedPath, serverPath.changelist_attribute
            ? obj.attributes[serverPath.changelist_attribute]
            : undefined);
        if (candidates === null || candidates.length === 0) {
            continue;
        }
        else {
            const bestCandidates = candidates
                .map(([candidatePath, candidateRevision]) => [
                (0, filepath_matching_1.calcScore)(obj.fullPath, candidatePath),
                [candidatePath, candidateRevision],
            ])
                .sort((a, b) => a[0] - b[0]);
            const [matchingFilepath, revision] = bestCandidates[bestCandidates.length - 1][1];
            const filelog = await (0, perforce_1.p4Filelog)(matchingFilepath, revision, serverPath);
            const { changelistId, changelistDate } = filelog || {
                changelistId: "1",
                changelistDate: new Date().toISOString(),
            };
            let changelistDescription;
            try {
                changelistDescription = await (0, perforce_1.p4Describe)(changelistId, serverPath);
            }
            catch (e) {
                log.warn("[p4Describe] error: " + e);
                changelistDescription = "";
            }
            const file = {
                perforceServer: serverPath,
                perforceServerId: serverPath.id,
                perforceServerName: serverPath.name,
                depotFilepath: matchingFilepath,
                fileRevision: revision,
                changelistId,
                changelistDescription,
                changelistDate: new Date(changelistDate),
            };
            return file;
        }
    }
    return null;
}
exports.getMatchingFile = getMatchingFile;
async function readGitmodules(repoId, commit, universeName, projectName) {
    if (typeof repoId === "string")
        repoId = parseInt(repoId, 10);
    const gitRepo = await getRepo(repoId);
    let submoduleText;
    try {
        submoduleText = await gitShow({
            repo: gitRepo,
            repoId,
            commitHashUnsanitized: commit,
            filePathUnsanitized: ".gitmodules",
            faultingLine: 0,
            surroundingLines: null,
            includeBlame: false,
            universeName,
            projectName,
        });
    }
    catch (e) {
        return {};
    }
    const submoduleData = {};
    let currentSubmodule = null;
    for (const line of submoduleText.fileContents
        .split("\n")
        .map((a) => a.trim())) {
        const re = /^\[submodule "(.*?)"\]/;
        const match = re.exec(line);
        if (match) {
            currentSubmodule = match[1];
            submoduleData[currentSubmodule] = { name: currentSubmodule };
        }
        else {
            const [key, val] = line
                .trim()
                .split("=")
                .map((x) => x.trim());
            if (currentSubmodule && key && val) {
                submoduleData[currentSubmodule][key] = val;
            }
        }
    }
    return submoduleData;
}
exports.readGitmodules = readGitmodules;
async function gitCloneExn(repo) {
    const { id, url, auth_type, user_name, password, ssh_private_key, ssh_public_key, universe_name, project_name, name, } = repo;
    const clonePath = repoPath(id);
    if (fs_1.default.existsSync(clonePath)) {
        rimraf_1.default.sync(clonePath);
    }
    if (auth_type === "user_pass" && user_name && password) {
        await newGit.cloneUserPassExn(url, clonePath, user_name, password);
    }
    else if (auth_type === "none") {
        await newGit.cloneOpenExn(url, clonePath);
    }
    else if (auth_type === "ssh_key" && ssh_public_key && ssh_private_key) {
        await newGit.cloneSSHExn(url, clonePath, ssh_private_key);
    }
    else {
        throw new Error(`Unknown auth_type ${auth_type}`);
    }
    log.info(`Cloned repo ${id} ${universe_name} ${project_name} ${name}`);
}
exports.gitCloneExn = gitCloneExn;
async function cloneRepo(db, repoInfo) {
    repoInfo.clone_status = "in_progress";
    const [id] = await db("repositories").insert(repoInfo);
    const dbRepo = await db("repositories").first("*").where("id", id);
    try {
        await gitCloneExn(dbRepo);
        await db("repositories").where("id", id).update({
            clone_status: "complete",
        });
        return id;
    }
    catch (e) {
        const msg = (0, util_1.toFriendlyErrMsg)(e.message);
        await db("repositories").where("id", id).update({
            clone_status: "error",
            clone_error: msg,
        });
        return id;
    }
}
exports.cloneRepo = cloneRepo;
function getSubmoduleInfoForDb(parentRepo, parentCommit, subName, subProps) {
    const url = subProps.url;
    const default_commit = subProps.default_commit || "master";
    let auth_type = "none";
    const user_name = null;
    const password = null;
    let ssh_public_key = null;
    let ssh_private_key = null;
    if (url) {
        const hasAtSymbol = /@/.test(url);
        const sshPrefix = new RegExp("ssh://").test(url);
        if (hasAtSymbol || sshPrefix) {
            auth_type = "ssh_key";
            ssh_public_key = parentRepo.ssh_public_key;
            ssh_private_key = parentRepo.ssh_private_key;
        }
    }
    return {
        name: subName,
        url,
        default_commit,
        auth_type,
        user_name,
        password,
        ssh_public_key,
        ssh_private_key,
        clone_status: "in_progress",
        universe_name: parentRepo.universe_name,
        project_name: parentRepo.project_name,
        submodule_parent_repo: String(parentRepo.id),
        submodule_origin_commit: parentCommit,
    };
}
exports.getSubmoduleInfoForDb = getSubmoduleInfoForDb;
async function getUnclonedSubmodules(db, repoId, commit, universeName, projectName) {
    const uncloned = [];
    const queue = [[repoId, commit]];
    while (queue.length > 0) {
        const item = queue.shift();
        if (!item)
            continue;
        const [parentRepoId, parentCommit] = item;
        const submodules = await readGitmodules(parentRepoId, parentCommit, universeName, projectName);
        for (const moduleName in submodules) {
            const dbRepo = await db("repositories")
                .first("*")
                .where("name", moduleName);
            if (!dbRepo) {
                uncloned.push(submodules[moduleName]);
            }
            else {
                const submCommitFromParent = await getSubmCommitFromParent(parentRepoId, await getRepo(parentRepoId), parentCommit, submodules[moduleName].path);
                if (submCommitFromParent != null) {
                    queue.push([dbRepo.id, submCommitFromParent]);
                }
            }
        }
    }
    return uncloned;
}
exports.getUnclonedSubmodules = getUnclonedSubmodules;
async function getUnclonedSubmodulesForProject(db, univName, projName, crashObj) {
    const ret = {};
    const repos = await getCandidateRepos(db, univName, projName, crashObj, new do_not_use_list_1.default());
    for (const repo of repos) {
        const commits = await getCommits(repo, crashObj.attributes, db, univName, projName);
        for (const commit of commits) {
            const uSubs = await getUnclonedSubmodules(db, repo.id, commit, univName, projName);
            for (const uSub of uSubs) {
                ret[uSub.name] = uSub;
            }
        }
    }
    return global.Object.values(ret);
}
exports.getUnclonedSubmodulesForProject = getUnclonedSubmodulesForProject;
async function cloneSubmodulesRecursivelyForProject(db, univName, projName, crashObj, universeName, projectName) {
    const nonSubmoduleRepos = (await getCandidateRepos(db, univName, projName, crashObj, new do_not_use_list_1.default())).filter((repo) => repo.submodule_parent_repo === null && repo.autoclone_submodules === 1);
    for (const repo of nonSubmoduleRepos) {
        const commits = await getCommits(repo, crashObj.attributes, db, universeName, projectName);
        for (const commit of commits) {
            await cloneSubmodulesRecursively(db, repo.id, commit, universeName, projectName);
        }
    }
}
exports.cloneSubmodulesRecursivelyForProject = cloneSubmodulesRecursivelyForProject;
async function cloneSubmodulesRecursively(db, repoId, commit, universeName, projectName) {
    const queue = [[repoId, commit]];
    while (queue.length > 0) {
        const item = queue.shift();
        if (!item)
            continue;
        const [parentRepoId, parentCommit] = item;
        const submodules = await readGitmodules(parentRepoId, parentCommit, universeName, projectName);
        for (const moduleName in submodules) {
            let dbRepo = await db("repositories")
                .first("*")
                .where("name", moduleName);
            if (!dbRepo) {
                const parentDbRepo = await db("repositories")
                    .first("*")
                    .where("id", parentRepoId);
                const info = thisModule.getSubmoduleInfoForDb(parentDbRepo, parentCommit, moduleName, submodules[moduleName]);
                try {
                    await cloneRepo(db, info);
                }
                catch (e) {
                    log.warn(`Unable to clone ${moduleName}: ${e.message}`);
                }
            }
            dbRepo = await db("repositories").first("*").where("name", moduleName);
            const submCommitFromParent = await getSubmCommitFromParent(parentRepoId, await getRepo(parentRepoId), parentCommit, submodules[moduleName].path);
            if (submCommitFromParent != null) {
                queue.push([dbRepo.id, submCommitFromParent]);
            }
        }
    }
}
exports.cloneSubmodulesRecursively = cloneSubmodulesRecursively;
async function getSubmoduleAncestor(db, subm) {
    let repo = subm;
    while (repo.submodule_parent_repo != null) {
        const parent_repo = repo.submodule_parent_repo;
        repo = await db("repositories").first("*").where("id", parent_repo);
    }
    return repo;
}
exports.getSubmoduleAncestor = getSubmoduleAncestor;
async function gitVersion() {
    return {
        path: gitCmdPath(),
        version: await gitCmd({ args: ["version"], timeout: 3000 }),
    };
}
exports.gitVersion = gitVersion;
const newGit = {
    async cloneOpenExn(url, clonePath) {
        await gitCmd({
            args: ["clone", "-q", url, clonePath],
            env: { GIT_TERMINAL_PROMPT: 0 },
            timeout: 0,
        });
    },
    async cloneUserPassExn(url, clonePath, user, pass) {
        let urlParts = url.split("://");
        if (urlParts.length != 2) {
            throw new Error(`Invalid url: ${url}`);
        }
        urlParts[0] = `${urlParts[0]}://${user}:${pass}`;
        url = urlParts.join("@");
        await gitCmd({ args: ["clone", "-q", url, clonePath], timeout: 0 });
    },
    async cloneSSHExn(url, clonePath, privKey) {
        await (0, ssh_1.addPrivateKeyToAgent)(privKey);
        const sshAgent = await (0, ssh_1.getAgent)();
        await gitCmd({
            args: ["clone", "-q", url, clonePath],
            env: Object.assign({ GIT_TERMINAL_PROMPT: 0 }, sshAgent),
            timeout: 0,
        });
    },
    async fetchOpenExn(clonePath) {
        return await gitCmd({
            args: ["fetch", "-q"],
            env: { GIT_TERMINAL_PROMPT: 0 },
            timeout: 0,
            cwd: clonePath,
        });
    },
    async fetchSSHExn(clonePath, privKey) {
        await (0, ssh_1.addPrivateKeyToAgent)(privKey);
        const sshAgent = await (0, ssh_1.getAgent)();
        await gitCmd({
            args: ["fetch", "-q"],
            env: Object.assign({ GIT_TERMINAL_PROMPT: 0 }, sshAgent),
            cwd: clonePath,
            timeout: 0,
        });
    },
    async fetchUserPassExn(clonePath) {
        await this.fetchOpenExn(clonePath);
    },
    async listRemotes(clonePath) {
        const stdout = await gitCmd({
            args: ["remote", "-v"],
            cwd: clonePath,
            timeout: 0,
        });
        return stdout
            .split("\n")
            .map((line) => line.split("\t"))
            .filter((pair) => pair.length === 2)
            .map((pair) => {
            const name = pair[0];
            const [url, remoteType] = pair[1].split(/\s/);
            return [name, url, remoteType];
        });
    },
    async removeRemote(clonePath, remoteName) {
        return await gitCmd({
            args: ["remote", "remove", remoteName],
            cwd: clonePath,
            timeout: 0,
            opts: {
                suppress_warnings: [new RegExp("no such remote", "i")],
            },
        });
    },
    async addRemoteExn(clonePath, remoteName, url) {
        return await gitCmd({
            args: ["remote", "add", remoteName, url],
            cwd: clonePath,
            timeout: 0,
        });
    },
    async addOrUpdateRemote(clonePath, remoteName, url) {
        await this.removeRemote(clonePath, remoteName);
        return await this.addRemoteExn(clonePath, remoteName, url);
    },
    async revParseExn(clonePath, commitIsh) {
        return await gitCmd({
            args: ["rev-parse", commitIsh],
            cwd: clonePath,
            timeout: 0,
        });
    },
    async revParse(clonePath, commitIsh) {
        try {
            return await this.revParseExn(clonePath, commitIsh);
        }
        catch (e) {
            return null;
        }
    },
    async getCommit(clonePath, commitIsh) {
        return await this.revParse(clonePath, commitIsh);
    },
    async verifyRepo(path) {
        return await gitCmd({
            args: ["rev-parse", "--is-inside-work-tree"],
            cwd: path,
            timeout: 0,
        });
    },
    async getRepo(repoId) {
        const pathToRepo = repoPath(repoId);
        await this.verifyRepo(pathToRepo);
        return { id: repoId, path: pathToRepo };
    },
};
exports.newGit = newGit;
//# sourceMappingURL=git_routines.js.map
//# debugId=076c3960-8467-d311-01b7-5935f5378066