
exports.up = function(knex) {
  return knex.schema.createTable('rules', function(t) {
    t.increments('id')
      .unsigned()
      .primary()
      .defaultTo(1);
    t.string('project_name').notNullable();
    t.index(['project_name'], 'rules_project_name_idx');
    t.string('universe_name').notNullable();
    t.index(['universe_name'], 'rules_universe_name_idx');
    t.integer('position').unsigned().notNullable();
    t.integer('matching_repository_id').unsigned().notNullable();
    t.foreign('matching_repository_id').references('id').inTable('repositories');
    t.enu('field_type', ['file_name', 'function_name', 'object_name', 'attribute']).notNullable();
    t.string('field_name').notNullable();
    t.string('regex').notNullable();
    t.timestamps(false, true);
  });
};

exports.down = function(knex) {
  return knex.schema.dropTable('rules');
};
