export type AccessSelector = {
    universe?: string;
    project: string;
};
/**
 * Backtrace available role
 */
export type BacktraceRole = 'none' | 'guest' | 'member' | 'admin';
/**
 * Determines if the @actualRole matches @requiredRole
 * @param requiredRole List of specific roles or one single role, If the single role is applied
 *  the algorithm will check with the respect or hierarchy. Otherwise, the method checks
 *  if the role exists in the array of roles
 * @param actualRole Actual user role
 * @returns true if the actual role covers required role
 */
export declare function isRoleAllowed(requiredRole: BacktraceRole | BacktraceRole[], actualRole: BacktraceRole): boolean;
